#include "StdAfx.h"
#include "WASGetMyRoomList.h"

CWASGetMyRoomList::CWASGetMyRoomList(CWASActor *pActor) : CWASCommand(pActor)
{
}

CWASGetMyRoomList::~CWASGetMyRoomList(void)
{
}

void CWASGetMyRoomList::ExecuteAsync()
{
	USES_UTF8_CONVERSION;

	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if(pMessengerActor == NULL)
	{
		return;
	}	
	
	m_listMyRoomData.clear();
	
	WSTRING strURL = m_pActor->GetWASServerAddress();
	strURL += _T("/ne/chat/GetMyRoomList.php");

	m_httpFacade.session().SetURL(W2U8(strURL.c_str()),	pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().SetMethod(HTTP_METHOD_POST);

	m_httpFacade.session().AddBodyVariable("userid", W2U8(pMessengerActor->GetUserID()));
	m_httpFacade.session().AddBodyVariable("langcode", W2U8(m_strLangCode.c_str()));
	m_httpFacade.session().AddBodyVariable("ticket", pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().AddBodyVariable("includeEmptyMsgRoom", W2U8(_T("y")));	// ȭ   Ʈ ޾ƿͼ óϱ .

	m_httpFacade.session().SetKeepRawHeader(TRUE);
	
	m_httpFacade.StopRequest();
	m_httpFacade.SendRequest(this);
}



bool CWASGetMyRoomList::ParseAndEventFire(nfc::CIkXMLDom * pDom)
{
	if(pDom == NULL)
		return false;

	do
	{
		USES_UTF8_CONVERSION;

		nfc::IIkXMLNodeList * pList1 = pDom->GetdocumentElement()->selectNodes("room");
		nfc::IIkXMLNodeList * pListMembers;
		nfc::IIkXMLNode *pListNode, *pChildNode, *pMemberNode;
		nfc::IIkXMLAttribute * pAttr;

		if(pList1 == NULL || pList1->Getlength() <= 0)
			break;

		for(int i = 0; i < pList1->Getlength(); i++)
		{
			NE_MYROOM_DATA sMyRoomData;
			pListNode = pList1->Getitem(i);
			pAttr = pListNode->getAttribute("id");
			if(pAttr == NULL)
				break;
			sMyRoomData.nRoomID = atoi(pAttr->Gettext().c_str());

			pChildNode = pListNode->selectSingleNode("server");
			pAttr = pChildNode->getAttribute("ipaddress");
			if(pAttr == NULL)
				break;
			sMyRoomData.strServerIP = U82W(pAttr->Gettext().c_str());
			
			pAttr = pChildNode->getAttribute("port");
			if(pAttr == NULL)
				break;
			sMyRoomData.nServerPort = atoi(pAttr->Gettext().c_str());

			pAttr = pChildNode->getAttribute("last_msg");
			if(pAttr == NULL)
				break;
			sMyRoomData.strLastMsg = U82W(pAttr->Gettext().c_str());

			pAttr = pChildNode->getAttribute("room_type");
			if(pAttr == NULL)
				break;
			sMyRoomData.nRoomType = atoi(pAttr->Gettext().c_str());

			pAttr = pChildNode->getAttribute("last_msg");
			if(pAttr == NULL)
				break;
			sMyRoomData.strLastMsg = U82W(pAttr->Gettext().c_str());

			pAttr = pChildNode->getAttribute("last_msg_user_id");
			if(pAttr == NULL)
				break;
			sMyRoomData.strLastMsgUserId = U82W(pAttr->Gettext().c_str());

			pAttr = pChildNode->getAttribute("last_msg_time");
			if(pAttr == NULL)
				break;
			sMyRoomData.nLastMsgTime = atoi(pAttr->Gettext().c_str());

			pAttr = pChildNode->getAttribute("last_msg_seq");
			if(pAttr == NULL)
				break;
			sMyRoomData.nLastMsgSeq = atoi(pAttr->Gettext().c_str());

			pAttr = pChildNode->getAttribute("trid");
			if(pAttr == NULL)
				break;
			sMyRoomData.nLastMsgTrid = atoi(pAttr->Gettext().c_str());

			pAttr = pChildNode->getAttribute("last_msg_type");
			if(pAttr == NULL)
				break;
			sMyRoomData.msgType = (BYTE)atoi(pAttr->Gettext().c_str());

			pListMembers = pListNode->selectNodes("member");
			if(pListMembers == NULL || pListMembers->Getlength() <= 0)
				break;
			
			for(int j = 0; j < pListMembers->Getlength(); j++)
			{
				NE_CHATMEMBER_DATA sChatMemberData;
				pMemberNode = pListMembers->Getitem(j);
				pAttr = pMemberNode->getAttribute("id");
				if(pAttr == NULL)
					break;
				sChatMemberData.strID = U82W(pAttr->Gettext().c_str());

				pAttr = pMemberNode->getAttribute("emp_nm");
				if(pAttr == NULL)
					break;
				sChatMemberData.strName = U82W(pAttr->Gettext().c_str());

				pAttr = pMemberNode->getAttribute("dept_nm");
				if(pAttr == NULL)
					break;
				sChatMemberData.strDepartmentName = U82W(pAttr->Gettext().c_str());

				pAttr = pMemberNode->getAttribute("jbps_nm");
				if(pAttr == NULL)
					break;
				sChatMemberData.strJobPositionName = U82W(pAttr->Gettext().c_str());

				pAttr = pMemberNode->getAttribute("nickname");
				if(pAttr == NULL)
					break;
				sChatMemberData.strNickName = U82W(pAttr->Gettext().c_str());

				sMyRoomData.listChatMemberData.push_back(sChatMemberData);
			}

			m_listMyRoomData.push_back(sMyRoomData);
		}
		

	} while(FALSE);

	return true;
}

// override in drived class
void CWASGetMyRoomList::OnWasResponse(trid_t trid,
								  bool bSuccess,
								  int /*nWinINetErrorCode*/, 
								  int /*nHttpResponseCode*/, 
                                  LPCSTR /*szWasResCodeInHeader*/, 
                                  LPCSTR szWasResCodeInXml,
                                  nfc::CIkXMLDom * pDom)
{
	if(bSuccess)
	{
		if(ParseAndEventFire(pDom) == false)
			m_eError = wasError_Protocol;
	}
	
	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEvent *pObserver = static_cast<IGTWASActorEvent *>(*it);
		if(pObserver->OnGTWASActor_ResponseGetMyRoomList(m_pActor, GetID(), m_eError, m_listMyRoomData) == false)
		{
			break;
		}
	}

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}


void CWASGetMyRoomList::OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/)
{
	m_eError = wasError_Timeout;

	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();	

	for (; it != observers.end(); ++it)
	{
		IGTWASActorEvent *pObserver = static_cast<IGTWASActorEvent *>(*it);
		if(pObserver->OnGTWASActor_ResponseGetMyRoomList(m_pActor, GetID(), m_eError, m_listMyRoomData) == false)
		{
			break;
		}
	}

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}
